﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls;
using Telerik.Windows.DragDrop;

namespace TreeListToTreeViewDragExample
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
			this.DataContext = new DataSource();
		}

		private void RadTreeListView_Loaded_1(object sender, RoutedEventArgs e)
		{
			RadTreeListView treeListView = (RadTreeListView)sender;
			//DragDropManager.AddDragOverHandler(treeListView, treeListView_DragOver);
		}

		void treeListView_DragOver(object sender, Telerik.Windows.DragDrop.DragEventArgs e)
		{
			e.Effects = DragDropEffects.None;
		}

		private void RadTreeView_Loaded_1(object sender, RoutedEventArgs e)
		{

		}
	}

	public class DataSource : BasePropertyNotifyClass
	{
		public ObservableCollection<Item> TreeListItems { get; set; }
		public ObservableCollection<Item> TreeItems { get; set; }

		public DataSource()
		{
			TreeListItems = new ObservableCollection<Item>();
			TreeListItems.Add(new Item() { Name = "Item 1", Description = "Some Description" });
			TreeListItems.Add(new Item() { Name = "Item 2", Description = "Some Description" });
			TreeListItems.Add(new Item() { Name = "Item 3", Description = "Some Description" });

			TreeItems = new ObservableCollection<Item>();
			TreeItems.Add(new Item() { Name = "Item A", Description = "Some Description" });
			TreeItems.Add(new Item() { Name = "Item B", Description = "Some Description" });
			TreeItems.Add(new Item() { Name = "Item C", Description = "Some Description" });
		}
	}

	public class Item : BasePropertyNotifyClass
	{
		public string Name { get; set; }
		public string Description { get; set; }
		public ObservableCollection<Item> ChildItems { get; set; }

		public Item()
		{
			ChildItems = new ObservableCollection<Item>();
		}

		public override string ToString()
		{
			return Name;
		}
	}

	public class BasePropertyNotifyClass : INotifyPropertyChanged
	{
		#region INotifyProperyChanged Interface
		public event PropertyChangedEventHandler PropertyChanged;
		protected void NotifyPropertyChanged(String propertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
		#endregion
	}
}
